package nc.impl.baiwang;

package ..deTemp.1733814907350;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.google.gson.Gson;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import nc.bs.dao.BaseDAO;
import nc.bs.framework.common.NCLocator;
import nc.impl.pubapp.pattern.data.vo.VOInsert;
import nc.itf.baiwang.IBaiWangItf;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.BeanListProcessor;
import nc.jdbc.framework.processor.BeanProcessor;
import nc.jdbc.framework.processor.ResultSetProcessor;
import nc.pub.rest.baiwang.vo.BaiWangApiLog;
import nc.pub.rest.baiwang.vo.ItfInvType;
import nc.pub.rest.baiwang.vo.SendHGAndDKDJ;
import nc.pub.rest.baiwang.vo.SendNormalInvoice;
import nc.pub.rest.baiwang.vo.SendTransInvoice;
import nc.pub.rest.baiwang.vo.SendTransferUpload;
import nc.pub.rest.util.BwConstType;
import nc.pub.rest.util.BwPostUtil;
import nc.pub.rest.util.DCToken;
import nc.tools.ConfiguraManage;
import nc.tools.Toolkits;
import nc.vo.arap.arap_bill_invoice.ArapBillInvoiceVO;
import nc.vo.bd.defdoc.DefdocVO;
import nc.vo.bd.inoutbusiclass.InoutBusiClassVO;
import nc.vo.ep.bx.BXBusItemVO;
import nc.vo.org.OrgVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.ISuperVO;
import nc.vo.pub.SuperVO;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDateTime;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nc.vo.sscivm.invoice.InvoiceLedgerInfoVO;

public class BaiWangImpl implements IBaiWangItf {
  BaseDAO baseDao = null;
  
  public BaseDAO getBaseDao() {
    if (this.baseDao == null)
      this.baseDao = new BaseDAO(); 
    return this.baseDao;
  }
  
  public void executeUpdateSql_RequiresNew(String sql) throws BusinessException {
    getBaseDao().executeUpdate(sql);
  }
  
  public void sendInvocie2Bw_RequiresNew(InvoiceLedgerInfoVO hvo) throws Exception {
    String billPk = hvo.getPrimaryKey();
    BaiWangApiLog errLog = new BaiWangApiLog();
    errLog.setDr(Integer.valueOf(0));
    errLog.setCreate_date((new UFDateTime()).toLocalString());
    errLog.setIs_succes("N");
    errLog.setBillpk(billPk);
    IBaiWangItf itf = (IBaiWangItf)NCLocator.getInstance().lookup(IBaiWangItf.class);
    itf.executeUpdateSql_RequiresNew("delete from baiwang_api_log where billpk='" + billPk + "' and is_succes='N'");
    try {
      InvoiceLedgerInfoVO oldVO = (InvoiceLedgerInfoVO)getBaseDao().retrieveByPK(InvoiceLedgerInfoVO.class, billPk);
      if (Toolkits.isEmpty(oldVO))
        ExceptionUtils.wrappBusinessException("记录已被删除，请刷新重试a"); 
      String vbillcode = oldVO.getCode();
      errLog.setVbillcode(vbillcode);
      String inv_type = oldVO.getInvoice_type();
      String sql = "select * from sscivm_invoice_type_map where oa_invoice_type='" + inv_type + "' and bw_invoice_type is not null";
      IUAPQueryBS iqbs = (IUAPQueryBS)NCLocator.getInstance().lookup(IUAPQueryBS.class);
      ItfInvType itfInvType = (ItfInvType)iqbs.executeQuery(sql, (ResultSetProcessor)new BeanProcessor(ItfInvType.class));
      if (Toolkits.isEmpty(itfInvType))
        ExceptionUtils.wrappBusinessException("单据号为【" + oldVO.getCode() + "】的记录，发票类型【" + inv_type + "】未对照，无法同步百望!"); 
      String token_url = ConfiguraManage.getSysInitValue("JTDC005");
      String itf_base_url = token_url.replace("/dcoauthedi/oauth/getToken", "");
      String period = oldVO.getPeriod();
      if (Toolkits.isEmpty(period))
        ExceptionUtils.wrappBusinessException("台账记录会计期间为空!"); 
      if (period.length() == 6) {
        period = String.valueOf(period.substring(0, 4)) + "-" + period.substring(4);
      } else {
        ExceptionUtils.wrappBusinessException("台账记录会计期间格式错误!");
      } 
      String invoice_number = oldVO.getInvoice_number();
      if (Toolkits.isEmpty(invoice_number))
        ExceptionUtils.wrappBusinessException("台账记录发票号码为空!"); 
      String source_billno = oldVO.getSource_billno();
      if (Toolkits.isEmpty(source_billno)) {
        source_billno = oldVO.getNc_source_billno();
        if (Toolkits.isEmpty(source_billno))
          ExceptionUtils.wrappBusinessException("台账记录【来源单号】【NC来源单号】不能同时为空!"); 
      } 
      String voucher_no = oldVO.getVoucher_no();
      if (Toolkits.isEmpty(voucher_no))
        ExceptionUtils.wrappBusinessException("台账记录凭证号为空!"); 
      String ncBillno = oldVO.getNc_source_billno();
      String bdSql = "select bi.* from ER_BXZB eb left join  er_busitem ebi on eb.pk_jkbx=ebi.pk_jkbx left join bd_inoutbusiclass bi on bi.pk_inoutbusiclass=ebi.szxmid where eb.djbh='" + 
        ncBillno + "' and ebi.fphm='" + invoice_number + "'";
      List<InoutBusiClassVO> inoutVoList = (List<InoutBusiClassVO>)iqbs.executeQuery(bdSql, (ResultSetProcessor)new BeanListProcessor(InoutBusiClassVO.class));
      String def3 = "";
      if (inoutVoList == null) {
        def3 = "false";
      } else if (inoutVoList.size() == 0) {
        def3 = "false";
      } else {
        def3 = "true";
        for (InoutBusiClassVO inoutVo : inoutVoList) {
          if (!"true".equals(inoutVo.getDef3()))
            def3 = "false"; 
        } 
      } 
      String itf_userName = ConfiguraManage.getSysInitValue("JTDC001");
      String itf_pwd = ConfiguraManage.getSysInitValue("JTDC002");
      String itf_syscode = ConfiguraManage.getSysInitValue("JTDC003");
      String itf_entryptStr = ConfiguraManage.getSysInitValue("JTDC004");
      DCToken.LoginDTO uatDTO = new DCToken.LoginDTO();
      uatDTO.setUserName(itf_userName);
      uatDTO.setPassword(itf_pwd);
      uatDTO.setSystemCode(itf_syscode);
      uatDTO.setEncryptionKey(DCToken.getEntryptStr(itf_entryptStr, uatDTO));
      System.out.println("数据中台Token的body入参：" + JSON.toJSONString(uatDTO));
      String reqTokenBody = JSON.toJSONString(uatDTO);
      BwPostUtil postUtil = new BwPostUtil();
      Map<String, String> headermap = new HashMap<>();
      JSONObject jsonObj = postUtil.postJson(reqTokenBody, token_url, headermap);
      Integer succ = jsonObj.getInteger("code");
      if (1 != succ.intValue()) {
        errLog.setNtype("getDCToken");
        errLog.setNname("获取中台token");
        errLog.setReq_json(subMsg(reqTokenBody));
        ExceptionUtils.wrappBusinessException("获取中台Token异常: " + jsonObj);
      } 
      headermap.put("token", jsonObj.getString("data"));
      String bw_code = itfInvType.getBw_invoice_type();
      String authApply = oldVO.getAuth_apply();
      UFBoolean uploaded = oldVO.getTrans_uploaded();
      if (BwConstType.INV_TYPE_HGJKS.equals(bw_code) || BwConstType.INV_TYPE_DKDJ.equals(bw_code)) {
        if (!"Y".equals(authApply)) {
          SendHGAndDKDJ dkdj = new SendHGAndDKDJ();
          if (BwConstType.INV_TYPE_HGJKS.equals(bw_code)) {
            dkdj.setPayment_certno(invoice_number);
            dkdj.setWithhold_voucher_no("");
            errLog.setNtype("nccSyncPaymentVoucher");
            errLog.setNname("海关缴纳书同步");
          } else {
            dkdj.setPayment_certno("");
            dkdj.setWithhold_voucher_no(invoice_number);
            errLog.setNtype("nccSyncPaymentVoucher");
            errLog.setNname("代扣代缴同步");
          } 
          dkdj.setAccounting_no(source_billno);
          dkdj.setAccounting_time(period);
          dkdj.setVoucher_no(voucher_no);
          Gson gson = new Gson();
          String json = gson.toJson(dkdj);
          String itf_url = String.valueOf(itf_base_url) + "/dcnccapi/forward/nccSyncPaymentVoucher";
          JSONObject resJson = postUtil.postJson(json, itf_url, headermap);
          System.out.println(resJson);
          succ = resJson.getInteger("code");
          if (1 != succ.intValue()) {
            String errorCode = "";
            try {
              JSONObject data = resJson.getJSONObject("data");
              JSONObject message = data.getJSONObject("message");
              errorCode = message.getString("errorCode");
            } catch (Exception e) {
              errLog.setReq_json(subMsg(json));
              ExceptionUtils.wrappBusinessException("海关缴纳书 、代扣代缴异常: " + resJson);
            } 
            if ("709".equals(errorCode)) {
              BaiWangApiLog log = getNewLog(billPk, vbillcode, "Y", errLog.getNtype(), errLog.getNname(), json, "709成功: " + resJson);
              itf.insertApiLog_RequiresNew(log);
            } else {
              errLog.setReq_json(subMsg(json));
              ExceptionUtils.wrappBusinessException("海关缴纳书 、代扣代缴异常: " + resJson);
            } 
          } else {
            BaiWangApiLog log = getNewLog(billPk, vbillcode, "Y", errLog.getNtype(), errLog.getNname(), json, "成功: " + resJson);
            itf.insertApiLog_RequiresNew(log);
          } 
          String flagSql = " update sscivm_invoice_ledgerInfo set auth_apply='Y' where pk_invoice_ledger='" + oldVO.getPrimaryKey() + "' ";
          itf.executeUpdateSql_RequiresNew(flagSql);
        } 
      } else {
        String buyer_taxno = oldVO.getBuyer_taxno();
        if (Toolkits.isEmpty(buyer_taxno))
          ExceptionUtils.wrappBusinessException("台账记录购方税号为空!"); 
        if (!"Y".equals(authApply)) {
          errLog.setNtype("nccLink2accstatusvat");
          errLog.setNname("发票记账信息同步");
          SendNormalInvoice normalInv = new SendNormalInvoice();
          normalInv.setTax_no(buyer_taxno);
          normalInv.setInvoice_type(bw_code);
          normalInv.setInvoice_code(oldVO.getInvoice_code());
          normalInv.setInvoice_number(invoice_number);
          normalInv.setAmount_use((String)oldVO.getTotal_price_with_tax());
          normalInv.setTax_use((String)oldVO.getTax());
          normalInv.setAccounting_no(source_billno);
          SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
          String date = format.format(Calendar.getInstance().getTime());
          normalInv.setApply_time(date);
          normalInv.setAccounting_time(period);
          normalInv.setVoucher_no(voucher_no);
          if ("true".equals(def3)) {
            normalInv.setNeed_voucher_flag("0");
          } else {
            normalInv.setNeed_voucher_flag("1");
          } 
          Gson gson = new Gson();
          String json = gson.toJson(normalInv);
          String itf_url = String.valueOf(itf_base_url) + "/dcnccapi/forward/nccLink2accstatusvat";
          JSONObject resJson = postUtil.postJson(json, itf_url, headermap);
          System.out.println(resJson);
          succ = resJson.getInteger("code");
          if (1 != succ.intValue()) {
            String errorCode = "";
            try {
              JSONObject data = resJson.getJSONObject("data");
              JSONObject message = data.getJSONObject("message");
              errorCode = message.getString("errorCode");
            } catch (Exception e) {
              errLog.setReq_json(subMsg(json));
              ExceptionUtils.wrappBusinessException("发票记账信息同步异常: " + resJson);
            } 
            if ("709".equals(errorCode)) {
              BaiWangApiLog log = getNewLog(billPk, vbillcode, "Y", errLog.getNtype(), errLog.getNname(), json, "709成功: " + resJson);
              itf.insertApiLog_RequiresNew(log);
            } else {
              errLog.setReq_json(subMsg(json));
              ExceptionUtils.wrappBusinessException("发票记账信息同步异常: " + resJson);
            } 
          } else {
            BaiWangApiLog log = getNewLog(billPk, vbillcode, "Y", errLog.getNtype(), errLog.getNname(), json, "成功: " + resJson);
            itf.insertApiLog_RequiresNew(log);
          } 
          String flagSql = " update sscivm_invoice_ledgerInfo set auth_apply='Y' where pk_invoice_ledger='" + oldVO.getPrimaryKey() + "' ";
          itf.executeUpdateSql_RequiresNew(flagSql);
        } 
        if ((uploaded == null || !uploaded.booleanValue()) && !"true".equals(def3)) {
          String cost_center = oldVO.getCost_center();
          if (Toolkits.isEmpty(cost_center))
            ExceptionUtils.wrappBusinessException("台账记录成本中心为空!"); 
          errLog.setNtype("nccBaiwangUpload");
          errLog.setNname("转出记录上传同步");
          SendTransferUpload transUp = new SendTransferUpload();
          transUp.setTax_no(buyer_taxno);
          transUp.setInvoice_code(oldVO.getInvoice_code());
          transUp.setInvoice_number(invoice_number);
          transUp.setInvoice_type(bw_code);
          String costSql = "select * from bd_defdoc where pk_defdoc='" + cost_center + "'";
          DefdocVO costCenterVO = (DefdocVO)iqbs.executeQuery(costSql, (ResultSetProcessor)new BeanProcessor(DefdocVO.class));
          if (Toolkits.isEmpty(costCenterVO))
            ExceptionUtils.wrappBusinessException("通过成本中心编码【" + cost_center + "】未匹配成本中心"); 
          transUp.setCost_center_code(costCenterVO.getCode());
          transUp.setCost_center_name(costCenterVO.getName());
          transUp.setVoucher_no(voucher_no);
          transUp.setAccount_tax_amount((String)oldVO.getTax());
          List<SendTransferUpload> upList = new ArrayList<>();
          upList.add(transUp);
          Gson gson_up = new Gson();
          String json_up = gson_up.toJson(upList);
          String itf_url_upload = String.valueOf(itf_base_url) + "/dcnccapi/forward/nccBaiwangUpload";
          JSONObject resJsonUpload = postUtil.postJson(json_up, itf_url_upload, headermap);
          succ = resJsonUpload.getInteger("code");
          if (1 != succ.intValue()) {
            errLog.setReq_json(subMsg(json_up));
            ExceptionUtils.wrappBusinessException("转出记录上传异常: " + resJsonUpload);
          } else {
            BaiWangApiLog log = getNewLog(billPk, vbillcode, "Y", errLog.getNtype(), errLog.getNname(), json_up, "成功: " + resJsonUpload);
            itf.insertApiLog_RequiresNew(log);
          } 
          String flagSql = " update sscivm_invoice_ledgerInfo set trans_uploaded='Y' where pk_invoice_ledger='" + oldVO.getPrimaryKey() + "' ";
          itf.executeUpdateSql_RequiresNew(flagSql);
        } 
      } 
    } catch (Exception e) {
      String errMsg = subMsg(e.getMessage());
      errLog.setErr_msg(errMsg);
      itf.insertApiLog_RequiresNew(errLog);
      throw e;
    } 
  }
  
  public void SendTransInvoiceBw_RequiresNew(InvoiceLedgerInfoVO hvo) throws Exception {
    String billPk = hvo.getPrimaryKey();
    BaiWangApiLog errLog = new BaiWangApiLog();
    errLog.setDr(Integer.valueOf(0));
    errLog.setCreate_date((new UFDateTime()).toLocalString());
    errLog.setBillpk(billPk);
    errLog.setNtype("batchCreate");
    errLog.setNname("旅客运输服务发票接口");
    IBaiWangItf itf = (IBaiWangItf)NCLocator.getInstance().lookup(IBaiWangItf.class);
    try {
      InvoiceLedgerInfoVO oldVO = (InvoiceLedgerInfoVO)getBaseDao().retrieveByPK(InvoiceLedgerInfoVO.class, billPk);
      if (Toolkits.isEmpty(oldVO))
        ExceptionUtils.wrappBusinessException("记录已被删除，请刷新重试a"); 
      String vbillcode = oldVO.getCode();
      errLog.setVbillcode(vbillcode);
      String inv_type = oldVO.getInvoice_type();
      String sql = "select * from sscivm_invoice_type_map where oa_invoice_type='" + inv_type + "' and bw_lkys_invoice_type is not null";
      IUAPQueryBS iqbs = (IUAPQueryBS)NCLocator.getInstance().lookup(IUAPQueryBS.class);
      ItfInvType itfInvType = (ItfInvType)iqbs.executeQuery(sql, (ResultSetProcessor)new BeanProcessor(ItfInvType.class));
      if (Toolkits.isEmpty(itfInvType))
        ExceptionUtils.wrappBusinessException("单据号为【" + oldVO.getCode() + "】的记录，发票类型【" + inv_type + "】未对照，无法同步百望!"); 
      String token_url = ConfiguraManage.getSysInitValue("JTDC005");
      String itf_base_url = token_url.replace("/dcoauthedi/oauth/getToken", "");
      String period = oldVO.getPeriod();
      if (Toolkits.isEmpty(period))
        ExceptionUtils.wrappBusinessException("台账记录会计期间为空!"); 
      if (period.length() == 6) {
        period = String.valueOf(period.substring(0, 4)) + "-" + period.substring(4);
      } else {
        ExceptionUtils.wrappBusinessException("台账记录会计期间格式错误!");
      } 
      String pk_org = oldVO.getPk_org();
      String orgSql = "select * from org_orgs where pk_org='" + pk_org + "'";
      OrgVO orgVO = (OrgVO)iqbs.executeQuery(orgSql, (ResultSetProcessor)new BeanProcessor(OrgVO.class));
      if (Toolkits.isEmpty(orgVO))
        ExceptionUtils.wrappBusinessException("台账记录组织为空!"); 
      UFDouble tax = oldVO.getTax();
      if (tax.doubleValue() == 0.0D)
        ExceptionUtils.wrappBusinessException("税额为0!"); 
      String invoice_type = oldVO.getInvoice_type();
      if (Toolkits.isEmpty(invoice_type))
        ExceptionUtils.wrappBusinessException("台账记录发票类型为空! "); 
      String itf_userName = ConfiguraManage.getSysInitValue("JTDC001");
      String itf_pwd = ConfiguraManage.getSysInitValue("JTDC002");
      String itf_syscode = ConfiguraManage.getSysInitValue("JTDC003");
      String itf_entryptStr = ConfiguraManage.getSysInitValue("JTDC004");
      DCToken.LoginDTO uatDTO = new DCToken.LoginDTO();
      uatDTO.setUserName(itf_userName);
      uatDTO.setPassword(itf_pwd);
      uatDTO.setSystemCode(itf_syscode);
      uatDTO.setEncryptionKey(DCToken.getEntryptStr(itf_entryptStr, uatDTO));
      System.out.println("数据中台Token的body入参：" + JSON.toJSONString(uatDTO));
      String reqTokenBody = JSON.toJSONString(uatDTO);
      BwPostUtil postUtil = new BwPostUtil();
      Map<String, String> headermap = new HashMap<>();
      JSONObject jsonObj = postUtil.postJson(reqTokenBody, token_url, headermap);
      Integer succ = jsonObj.getInteger("code");
      if (1 != succ.intValue()) {
        errLog.setNtype("getDCToken");
        errLog.setNname("获取中台token");
        errLog.setReq_json(subMsg(reqTokenBody));
        ExceptionUtils.wrappBusinessException("获取中台Token异常: " + jsonObj);
      } 
      headermap.put("token", jsonObj.getString("data"));
      String authApply = oldVO.getAuth_apply();
      String invoiceType = oldVO.getInvoice_type();
      StringBuilder bdSql = new StringBuilder();
      String ncBillno = oldVO.getNc_source_billno();
      String invoice_number = oldVO.getInvoice_number();
      bdSql.append("select ebi.* from ER_BXZB eb ");
      bdSql.append("left join  er_busitem ebi on eb.pk_jkbx=ebi.pk_jkbx ");
      bdSql.append("left join bd_inoutbusiclass bi on bi.pk_inoutbusiclass=ebi.szxmid ");
      bdSql.append("where eb.djbh='" + ncBillno + "' and ebi.fphm='" + invoice_number + "' ");
      BXBusItemVO busItemVO = (BXBusItemVO)iqbs.executeQuery(bdSql.toString(), (ResultSetProcessor)new BeanProcessor(BXBusItemVO.class));
      if (!"Y".equals(authApply) && busItemVO != null) {
        List<SendTransInvoice> list = new ArrayList<>();
        SendTransInvoice sInvoice = new SendTransInvoice();
        sInvoice.setInvoiceNo(oldVO.getInvoice_number());
        sInvoice.setIncomeMonth(oldVO.getPeriod());
        sInvoice.setTotalTax(oldVO.getTax().toString());
        sInvoice.setDeductTax(oldVO.getTax().toString());
        sInvoice.setTotalAmount(oldVO.getTax_exclusive().toString());
        sInvoice.setAmountTax(busItemVO.getVat_amount().toString());
        sInvoice.setInvoiceTypeCode(itfInvType.getBw_lkys_invoice_type());
        sInvoice.setOrderNo(Long.valueOf(System.currentTimeMillis()));
        sInvoice.setReimbursementNo(oldVO.getSource_billno());
        sInvoice.setInvoiceDate((oldVO.getInvoice_date() == null) ? "" : oldVO.getInvoice_date().toString().substring(0, 10));
        list.add(sInvoice);
        Map<String, Object> map = new HashMap<>();
        map.put("isForceOverwrite", Integer.valueOf(1));
        map.put("orgCode", orgVO.getCode());
        map.put("orgName", orgVO.getName());
        map.put("nonVatInvoiceDtoList", list);
        Gson gson_up = new Gson();
        String sInvoiceJson = gson_up.toJson(map);
        JSONObject respJson = postUtil.postJson(sInvoiceJson, String.valueOf(itf_base_url) + "/dcnccapi/nccToBw/invoice", headermap);
        JSONObject dataJsonObject = respJson.getJSONObject("data");
        String isSucc = dataJsonObject.getString("success");
        if ("true".equals(isSucc)) {
          errLog.setIs_succes("Y");
          errLog.setReq_json(subMsg(sInvoiceJson));
          errLog.setErr_msg("成功:" + respJson.toJSONString());
          String flagSql = " update sscivm_invoice_ledgerInfo set auth_apply='Y' where pk_invoice_ledger='" + oldVO.getPrimaryKey() + "' ";
          itf.executeUpdateSql_RequiresNew(flagSql);
        } else {
          errLog.setIs_succes("N");
          errLog.setReq_json(subMsg(sInvoiceJson));
          errLog.setErr_msg("旅客运输服务发票接口异常: " + respJson);
          ExceptionUtils.wrappBusinessException("旅客运输服务发票接口异常: " + respJson);
        } 
        itf.insertApiLog_RequiresNew(errLog);
      } else if (!"Y".equals(authApply) && busItemVO == null) {
        List<SendTransInvoice> list = new ArrayList<>();
        SendTransInvoice sInvoice = new SendTransInvoice();
        sInvoice.setInvoiceNo(oldVO.getInvoice_number());
        sInvoice.setIncomeMonth(oldVO.getPeriod());
        sInvoice.setTotalTax(oldVO.getTax().toString());
        sInvoice.setDeductTax(oldVO.getTax().toString());
        sInvoice.setTotalAmount(oldVO.getTax_exclusive().toString());
        sInvoice.setAmountTax(oldVO.getTotal_price_with_tax().toString());
        sInvoice.setInvoiceTypeCode(itfInvType.getBw_lkys_invoice_type());
        sInvoice.setOrderNo(Long.valueOf(System.currentTimeMillis()));
        sInvoice.setReimbursementNo(oldVO.getSource_billno());
        sInvoice.setInvoiceDate((oldVO.getInvoice_date() == null) ? "" : oldVO.getInvoice_date().toString().substring(0, 10));
        list.add(sInvoice);
        Map<String, Object> map = new HashMap<>();
        map.put("isForceOverwrite", Integer.valueOf(1));
        map.put("orgCode", orgVO.getCode());
        map.put("orgName", orgVO.getName());
        map.put("nonVatInvoiceDtoList", list);
        Gson gson_up = new Gson();
        String sInvoiceJson = gson_up.toJson(map);
        JSONObject respJson = postUtil.postJson(sInvoiceJson, String.valueOf(itf_base_url) + "/dcnccapi/nccToBw/invoice", headermap);
        JSONObject dataJsonObject = respJson.getJSONObject("data");
        String isSucc = dataJsonObject.getString("success");
        if ("true".equals(isSucc)) {
          errLog.setIs_succes("Y");
          errLog.setReq_json(subMsg(sInvoiceJson));
          errLog.setErr_msg("成功:" + respJson.toJSONString());
          String flagSql = " update sscivm_invoice_ledgerInfo set auth_apply='Y' where pk_invoice_ledger='" + oldVO.getPrimaryKey() + "' ";
          itf.executeUpdateSql_RequiresNew(flagSql);
        } else {
          errLog.setIs_succes("N");
          errLog.setReq_json(subMsg(sInvoiceJson));
          errLog.setErr_msg("旅客运输服务发票接口异常: " + respJson);
          ExceptionUtils.wrappBusinessException("旅客运输服务发票接口异常: " + respJson);
        } 
        itf.insertApiLog_RequiresNew(errLog);
      } 
    } catch (Exception e) {
      String errMsg = subMsg(e.getMessage());
      errLog.setErr_msg(errMsg);
      errLog.setIs_succes("N");
      itf.insertApiLog_RequiresNew(errLog);
      throw e;
    } 
  }
  
  private BaiWangApiLog getNewLog(String billPk, String vbillcode, String is_success, String ntype, String nname, String reqJson, String errMsg) {
    BaiWangApiLog log = new BaiWangApiLog();
    log.setDr(Integer.valueOf(0));
    log.setCreate_date((new UFDateTime()).toLocalString());
    log.setIs_succes(is_success);
    log.setBillpk(billPk);
    log.setVbillcode(vbillcode);
    log.setNtype(ntype);
    log.setNname(nname);
    log.setReq_json(subMsg(reqJson));
    log.setErr_msg(subMsg(errMsg));
    return log;
  }
  
  public String subMsg(String errMsg) {
    if (errMsg != null && errMsg.length() > 750)
      errMsg = errMsg.substring(0, 750); 
    return errMsg;
  }
  
  public ArapBillInvoiceVO[] insertArapBillInvoice(ArapBillInvoiceVO[] arapInvoiceVOs) throws Exception {
    VOInsert<ArapBillInvoiceVO> voi = new VOInsert();
    return (ArapBillInvoiceVO[])voi.insert((ISuperVO[])arapInvoiceVOs);
  }
  
  public void insertApiLog_RequiresNew(BaiWangApiLog log) throws Exception {
    getBaseDao().insertVO((SuperVO)log);
  }
}
